//*****************************************************************************
//*
//*
//*		GameSpell.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"GameSpell.h"
#include	"MainFrm.h"
#include	"GameSpellDoc.h"
#include	"GameSpellView.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


BEGIN_MESSAGE_MAP(CGameSpellApp, CWinApp)
	//{{AFX_MSG_MAP(CGameSpellApp)
	ON_COMMAND(ID_APP_ABOUT		,OnAppAbout)
	ON_COMMAND(ID_FILEFORMAT	,OnFileFormat)
	ON_COMMAND(ID_KEYSETTINGS	,OnKeySettings)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_NEW,         CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

WAPP_FUNC (CGameSpellApp)
LOAD_LAST1(CGameSpellApp)

CGameSpellApp theApp;

//*****************************************************************************
//*
//*		CGameSpellApp
//*
//*****************************************************************************
//  CGameSpellApp Konstruktion
CGameSpellApp::CGameSpellApp()
{
}

//*****************************************************************************
//*
//*		InitInstance
//*
//*****************************************************************************
//  CGameSpellApp Initialisierung
BOOL CGameSpellApp::InitInstance()
{
LPCTSTR			pParam;
int				iPos;


	AfxEnableControlContainer();


	#ifdef		_AFXDLL 				
	Enable3dControls(); 									// Diese Funktion bei Verwendung von MFC in gemeinsam genutzten DLLs aufrufen
	#else
	Enable3dControlsStatic();								// Diese Funktion bei statischen MFC-Anbindungen aufrufen
	#endif

	AfxUtilityInit();

	SetRegistryKey(_T("AZ"));

	LoadStdProfileSettings();								// Standard INI-Dateioptionen laden (einschlielich MRU)


	pDocTemplate = new CSingleDocTemplate(IDR_MAINFRAME,RUNTIME_CLASS(CGameSpellDoc),RUNTIME_CLASS(CMainFrame),RUNTIME_CLASS(CGameSpellView));	// Haupt-SDI-Rahmenfenster
	AddDocTemplate(pDocTemplate);

	CCommandLineInfo cmdInfo;

	if(!ProcessShellCommand(cmdInfo))
		{
		return FALSE;
		}


	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();


	for(iPos=1;iPos<__argc;iPos++)							// Parameter auswerten
		{
		pParam = __targv[iPos];

		if(pParam[0]!='-' && pParam[0]!='/')
			{
			CGameSpellView *pView;

			   pView = (CGameSpellView*)GetView();
			if(pView)pView->SetStartPath(pParam);

			continue;
			}

		if(pParam[1]=='Z' || pParam[1]=='z')
			{
			m_pMainWnd->PostMessage(WM_COMMAND,ID_ZOOM);
			continue;
			}
		}


return TRUE;
}



//*****************************************************************************
//*
//*		OnAppAbout
//*
//*****************************************************************************
//  Anwendungsbefehl zum Ausfhren des Dialogfelds
void CGameSpellApp::OnAppAbout()
{
CDialog	sDlg(IDD_ABOUTBOX);


	sDlg.DoModal();


}

//*****************************************************************************
//*
//*		OnFileFormat
//*
//*****************************************************************************
void CGameSpellApp::OnFileFormat()
{
CDialog	sDlg(IDD_FILEFORMAT);


	sDlg.DoModal();

}

//*****************************************************************************
//*
//*		OnKeySettings
//*
//*****************************************************************************
void CGameSpellApp::OnKeySettings()
{
CDialog	sDlg(IDD_KEYSETTINGS);


	sDlg.DoModal();


}
