//*****************************************************************************
//*
//*
//*		GameSpellView.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"GameSpell.h"
#include	"GameSpellDoc.h"
#include	"GameSpellView.h"
#include	"System/ComUtility.h"
#include	<mmsystem.h>
#include	"NewPicDlg.h"
#include	"WinAudio.h"
#include	"MainFrm.h"
#include	<math.h>

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#ifndef 	 DC_PEN
#define		 DC_PEN				19
#endif
#ifndef		 DC_BRUSH
#define 	 DC_BRUSH			18
#endif
#ifndef 	 AC_SRC_ALPHA
#define		 AC_SRC_ALPHA       0x01
#endif
#ifndef		 IDC_HAND
#define		 IDC_HAND			MAKEINTRESOURCE(32649)
#endif

#define		 PI					3.1415926535897932384626433832795
#define 	 HIDE_COLOR			BGR(208,208,208)	
#define 	 TEXT_COLOR			BGR(255,255,73)	
#define 	 BACK_COLOR			BGR(0,0,0)
#define 	 AUDIO_BUFFER		0x4000
#define 	 IDC_UPDATE			0x39AE
#define 	 MAX_POINTS			8
#define 	 FRAME_SIZE			6
#define 	 TEXT_LINE			42


#if (_WIN32_WINNT < 0x0500)
extern "C"	 WINGDIAPI COLORREF __stdcall SetDCBrushColor(HDC, COLORREF);
extern "C"   WINGDIAPI COLORREF __stdcall SetDCPenColor(HDC, COLORREF);
#endif



IMPLEMENT_DYNCREATE(CGameSpellView, CView)

BEGIN_MESSAGE_MAP(CGameSpellView, CView)
	//{{AFX_MSG_MAP(CGameSpellView)
	ON_WM_SIZE()
	ON_WM_TIMER()
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_KEYDOWN()
	ON_WM_SETFOCUS()
	ON_COMMAND(ID_RESET					,OnReset)
	ON_COMMAND(ID_START					,OnStart)
	ON_COMMAND(ID_STOP1					,OnStop1)
	ON_COMMAND(ID_STOP2					,OnStop2)
	ON_COMMAND(ID_STOP1EX				,OnStop1)
	ON_COMMAND(ID_STOP2EX				,OnStop2)
	ON_COMMAND(ID_FILE_NEW				,OnNewText)
	ON_COMMAND(ID_CHARTIME				,OnPicTime)
	ON_COMMAND(ID_CHARPATH				,OnPicPath)
	ON_COMMAND(ID_STARADD1				,OnStarAdd1)
	ON_COMMAND(ID_STARADD2				,OnStarAdd2)
	ON_COMMAND(ID_STARSUB1				,OnStarSub1)
	ON_COMMAND(ID_STARSUB2				,OnStarSub2)
	ON_COMMAND(ID_NEXTGAME				,OnNextGame)
	ON_COMMAND(ID_USEIMAGE_A			,OnUseImageA)
	ON_COMMAND(ID_USEIMAGE_B			,OnUseImageB)
	ON_COMMAND(ID_USEIMAGE_C			,OnUseImageC)
	ON_COMMAND(ID_USEIMAGE_D			,OnUseImageD)
	ON_COMMAND(ID_SELCOMPORT			,OnSelComPort)
	ON_COMMAND(ID_SEC_TICKER			,OnSecTicker)
	ON_UPDATE_COMMAND_UI(ID_FILE_NEW	,OnNewTextUI)
	ON_UPDATE_COMMAND_UI(ID_SEC_TICKER	,OnSecTickerUI)
	ON_UPDATE_COMMAND_UI(ID_USEIMAGE_A	,OnUseImageAUI)
	ON_UPDATE_COMMAND_UI(ID_USEIMAGE_B	,OnUseImageBUI)
	ON_UPDATE_COMMAND_UI(ID_USEIMAGE_C	,OnUseImageCUI)
	ON_UPDATE_COMMAND_UI(ID_USEIMAGE_D	,OnUseImageDUI)
	ON_UPDATE_COMMAND_UI(ID_STOP1EX		,OnStop1Ex)
	ON_UPDATE_COMMAND_UI(ID_STOP2EX		,OnStop2Ex)
	ON_UPDATE_COMMAND_UI(ID_STOP1 		,OnStop1UI)
	ON_UPDATE_COMMAND_UI(ID_STOP2 		,OnStop2UI)
	ON_UPDATE_COMMAND_UI(ID_START 		,OnStartUI)
	ON_UPDATE_COMMAND_UI(ID_RESET		,OnResetUI)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


DWORD	CGameSpellView::m_uLastCling;
short  *CGameSpellView::m_pCling1;
UINT	CGameSpellView::m_uCling1Len;
HRSRC	CGameSpellView::m_hCling1Src;
HGLOBAL	CGameSpellView::m_hCling1Hg;
short  *CGameSpellView::m_pCling2;
UINT	CGameSpellView::m_uCling2Len;
HRSRC	CGameSpellView::m_hCling2Src;
HGLOBAL	CGameSpellView::m_hCling2Hg;
short  *CGameSpellView::m_pError;
UINT	CGameSpellView::m_uErrorLen;
HRSRC	CGameSpellView::m_hErrorSrc;
HGLOBAL	CGameSpellView::m_hErrorHg;
short  *CGameSpellView::m_pTuck;
UINT	CGameSpellView::m_uTuckLen;
HRSRC	CGameSpellView::m_hTuckSrc;
HGLOBAL	CGameSpellView::m_hTuckHg;
short  *CGameSpellView::m_pTick;
UINT	CGameSpellView::m_uTickLen;
HRSRC	CGameSpellView::m_hTickSrc;
HGLOBAL	CGameSpellView::m_hTickHg;
short  *CGameSpellView::m_aPlay[4];
UINT	CGameSpellView::m_aPlayLen[4];
DWORD	CGameSpellView::m_aHgColors[] =
			{
			BGR(0,0,0),
			BGR(188,188,0),
			BGR(255,0,0),
			};
BYTE	CGameSpellView::m_aFont[] =
			{
			#include "Image/Fonts/Arial24.h"
			};

BYTE	CGameSpellView::m_aFontX[] =
			{
			#include "Image/Fonts/Arial16.h"
			};

BYTE	CGameSpellView::m_aFontS[] =
			{
			#include "Image/Fonts/Arial12.h"
			};

extern "C"	int ComCheckPort(int iHandle);

//*****************************************************************************
//*
//*		CGameSpellView
//*
//*****************************************************************************
//  CGameSpellView Konstruktion/Destruktion
CGameSpellView::CGameSpellView()
{
CRegKeys	sKey;



	m_uGameNumber	= 0;
	m_uSwitchTime	= 5000;
	m_bRunning		= 0;
	m_iWndSizeX		= 0;
	m_iWndSizeY		= 0;
	m_iNumberX		= 0;
	m_iNumberY		= 0;
	m_uDeltaTick	= 0;
	m_uStartTick	= 0;
	m_uTimerTick	= 0;	
	m_aTextInfo[0]  = 0;
	m_aTextMain[0]  = 0;
	m_aPoints  [0]	= 0;
	m_aPoints  [1]	= 0;
	m_aBgNum   [0]	= 0;
	m_aBgNum   [1]	= 0;
	m_aStop    [0]	= 0;
	m_aStop    [1]	= 0;
	m_iStop			= 0;
	m_iDone			= 0;
	m_iPort			= 0;
	m_iTextMax		= 0;
	m_iTextDraw		= 1;
	m_iTextLines	= 0;
	m_iTextCount	= 0;	
	m_uLastTick		= 0;
	m_iInfoDraw		= 1;
	m_iStarSize		= 0;
	m_iZoom			= 0;
	m_iStarX		= 136;
	m_iStarY		= 136;
	m_iStarMax		= MAX_POINTS;
	m_iStarRows		= 1;
	m_iSecTicker	= 1;

	sKey.Open();
	sKey.Get(m_uSwitchTime,"SwitchTime");
	sKey.Get(m_iSecTicker ,"SecTicker" );
	sKey.Get(m_iStarSize  ,"StarSize"  );
	sKey.Get(m_sPicPath	  ,"PicPath"   );
	sKey.Get((int)m_iPort ,"ComPort"   );

	if(m_uSwitchTime< 2000)m_uSwitchTime=2000;
	if(m_uSwitchTime>10000)m_uSwitchTime=10000;

	m_uSwitchUsed = m_uSwitchTime;

	memset(m_aStars,0xFF,sizeof(m_aStars));

	srand(GetTickCount()^time(0));

}

//*****************************************************************************
//*
//*		CGameSpellView
//*
//*****************************************************************************
CGameSpellView::~CGameSpellView()
{
CRegKeys	sKey;


	sKey.Open();
	sKey.Set(m_uSwitchTime,"SwitchTime");
	sKey.Set(m_iSecTicker ,"SecTicker" );
	sKey.Set(m_iStarSize  ,"StarSize"  );
	sKey.Set(m_sPicPath	  ,"PicPath"   );
	sKey.Set(m_iPort	  ,"ComPort"   );

	while(!m_iDone)
		{
		m_iStop = 1;
		Sleep(50);
		}

}

//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CGameSpellView::PreCreateWindow(CREATESTRUCT &sCreate)
{

return CView::PreCreateWindow(sCreate);
}


//*****************************************************************************
//*
//*		Draw
//*
//*****************************************************************************
void _cdecl Draw(void *pParam,CDC *pDc,PAINTSTRUCT *pPaint)
{

	pDc->SelectStockObject(BLACK_PEN);
	pDc->SelectStockObject(DKGRAY_BRUSH);
	pDc->Rectangle(10,10,20,20);

}

//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int CGameSpellView::OnCreate(LPCREATESTRUCT pCreateStruct)
{
DWORD		dwThread;
HANDLE		hThread;
CRect		sRect;
LPBYTE		pData;
UINT		uSize;
UINT		uPos;
UINT		uLen;



	if(CView::OnCreate(pCreateStruct)==-1)
		{
		return -1;
		}

	if(!m_sTextFont.CreateFont(128,72,0,0,FW_NORMAL,0,0,0,ANSI_CHARSET,OUT_RASTER_PRECIS,CLIP_STROKE_PRECIS,DEFAULT_QUALITY,FIXED_PITCH,"Courier New"))
		{
		if(!m_sTextFont.CreateFont(128,72,0,0,FW_NORMAL,0,0,0,ANSI_CHARSET,OUT_RASTER_PRECIS,CLIP_STROKE_PRECIS,DEFAULT_QUALITY,FIXED_PITCH,"Courier"))
			{
			m_sTextFont.CreateFont(128,72,0,0,FW_NORMAL,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,FF_SWISS,NULL);
			}
		}

	SetClassLongPtr(m_hWnd,GCLP_HBRBACKGROUND,(LPARAM)NULL);

	sRect.SetRectEmpty();
	m_cBitmapWnd.Create(WS_CHILD|WS_VISIBLE,sRect,this);
	m_cBitmapWnd.SetBkColor(RGB(0,0,0));

	m_sStarImg1.InsertBitmap(IDB_STAR1);
	m_sStarImg2.InsertBitmap(IDB_STAR2);
	m_sStarImg3.InsertBitmap(IDB_STAR3);

	SelectStar(m_iStarSize);

	hThread = CreateThread(NULL,0x8000,ComThread,this,0,&dwThread);
	CloseHandle(hThread);

	SetTimer(IDC_UPDATE,50,NULL);



	   m_hCling1Src=FindResourceA(NULL,"CLING1","WAVE");
	if(m_hCling1Src)
		{
		m_hCling1Hg	= LoadResource  (NULL,m_hCling1Src);
		uSize		= SizeofResource(NULL,m_hCling1Src);
		pData		= (LPBYTE)LockResource(m_hCling1Hg);

		for(uPos=12;uPos<4096 && uPos+16<uSize;uPos+=uLen+8)
			{
			uLen = *((DWORD*)(pData+uPos+4));
			if(memcmp(pData+uPos,"data",4))continue;
			uPos += 8;
			if(uPos+uLen>uSize)break;
			m_pCling1	 = (short*)(pData+uPos);
			m_uCling1Len = uLen/2;
			break;
			}
		}

	   m_hCling2Src=FindResourceA(NULL,"CLING2","WAVE");
	if(m_hCling2Src)
		{
		m_hCling2Hg	= LoadResource  (NULL,m_hCling2Src);
		uSize		= SizeofResource(NULL,m_hCling2Src);
		pData		= (LPBYTE)LockResource(m_hCling2Hg);

		for(uPos=12;uPos<4096 && uPos+16<uSize;uPos+=uLen+8)
			{
			uLen = *((DWORD*)(pData+uPos+4));
			if(memcmp(pData+uPos,"data",4))continue;
			uPos += 8;
			if(uPos+uLen>uSize)break;
			m_pCling2	 = (short*)(pData+uPos);
			m_uCling2Len = uLen/2;
			break;
			}
		}

	   m_hErrorSrc=FindResourceA(NULL,"ERROR","WAVE");
	if(m_hErrorSrc)
		{
		m_hErrorHg	= LoadResource  (NULL,m_hErrorSrc);
		uSize		= SizeofResource(NULL,m_hErrorSrc);
		pData		= (LPBYTE)LockResource(m_hErrorHg);

		for(uPos=12;uPos<4096 && uPos+16<uSize;uPos+=uLen+8)
			{
			uLen = *((DWORD*)(pData+uPos+4));
			if(memcmp(pData+uPos,"data",4))continue;
			uPos += 8;
			if(uPos+uLen>uSize)break;
			m_pError	 = (short*)(pData+uPos);
			m_uErrorLen = uLen/2;
			break;
			}

		while(m_uErrorLen>0 && *m_pError==0)
			{
			m_uErrorLen--;
			m_pError++;
			}
		}


	   m_hTuckSrc=FindResourceA(NULL,"TUCK","WAVE");
	if(m_hTuckSrc)
		{
		m_hTuckHg	= LoadResource  (NULL,m_hTuckSrc);
		uSize		= SizeofResource(NULL,m_hTuckSrc);
		pData		= (LPBYTE)LockResource(m_hTuckHg);

		for(uPos=12;uPos<4096 && uPos+16<uSize;uPos+=uLen+8)
			{
			uLen = *((DWORD*)(pData+uPos+4));
			if(memcmp(pData+uPos,"data",4))continue;
			uPos += 8;
			if(uPos+uLen>uSize)break;
			m_pTuck	 = (short*)(pData+uPos);
			m_uTuckLen = uLen/2;
			break;
			}

		while(m_uTuckLen>0 && *m_pTuck==0)
			{
			m_uTuckLen--;
			m_pTuck++;
			}
		}

	   m_hTickSrc=FindResourceA(NULL,"TICK","WAVE");
	if(m_hTickSrc)
		{
		m_hTickHg	= LoadResource  (NULL,m_hTickSrc);
		uSize		= SizeofResource(NULL,m_hTickSrc);
		pData		= (LPBYTE)LockResource(m_hTickHg);

		for(uPos=12;uPos<4096 && uPos+16<uSize;uPos+=uLen+8)
			{
			uLen = *((DWORD*)(pData+uPos+4));
			if(memcmp(pData+uPos,"data",4))continue;
			uPos += 8;
			if(uPos+uLen>uSize)break;
			m_pTick	 = (short*)(pData+uPos);
			m_uTickLen = uLen/2;
			break;
			}
		}


	if(ExistFile(m_sPicPath)<2)
		{
		PostMessage(WM_COMMAND,ID_CHARPATH);
		}


return 0;
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CGameSpellView::OnDestroy()
{

	AfxGetMainWnd()->ShowWindow(SW_HIDE);

	UnlockResource(m_hCling1Hg );
	DeleteObject  (m_hCling1Src);
	UnlockResource(m_hCling2Hg );
	DeleteObject  (m_hCling2Src);
	UnlockResource(m_hErrorHg  );
	DeleteObject  (m_hErrorSrc );
	UnlockResource(m_hTuckHg   );
	DeleteObject  (m_hTuckSrc  );
	UnlockResource(m_hTickHg   );
	DeleteObject  (m_hTickSrc  );

	CView::OnDestroy();

}

//*****************************************************************************
//*
//*		OnDraw
//*
//*****************************************************************************
//  CGameSpellView Zeichnen
void CGameSpellView::OnDraw(CDC *pDC)
{
CGameSpellDoc  *pDoc = GetDocument();


	ASSERT_VALID(pDoc);

}

//*****************************************************************************
//*
//*		AssertValid
//*
//*****************************************************************************
#ifdef		_DEBUG
void CGameSpellView::AssertValid() const
{
	CView::AssertValid();
}

//*****************************************************************************
//*
//*		Dump
//*
//*****************************************************************************
void CGameSpellView::Dump(CDumpContext &dc) const
{
	CView::Dump(dc);
}
#endif

//*****************************************************************************
//*
//*		GetDocument
//*
//*****************************************************************************
#ifdef		_DEBUG
CGameSpellDoc *CGameSpellView::GetDocument()
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CGameSpellDoc)));

return (CGameSpellDoc*)m_pDocument;
}
#endif

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CGameSpellView::OnSize(UINT nType,int iSizeX,int iSizeY)
{
BitmapImage	   *pImage;



	if(iSizeX && iSizeY)
		{
		pImage	=  m_cBitmapWnd.GetImage();
		pImage->Box(0,0,iSizeX,iSizeY,BGR(0,0,0));
		memset(m_aStars,0xFF,sizeof(m_aStars));
		SizeWindow(&m_cBitmapWnd,iSizeX,iSizeY);
		m_iWndSizeX   = iSizeX;
		m_iWndSizeY   = iSizeY;
		m_uHgOk		  = 0xFF;
		m_iInfoDraw	  = 1;
		m_iTextDraw	  = 1; 	  	
		}

	CView::OnSize(nType,iSizeX,iSizeY);

}

//*****************************************************************************
//*
//*		OnUpdate
//*
//*****************************************************************************
void CGameSpellView::OnUpdate(CView *pSender,LPARAM lHint,CObject *pHint)
{



}

//*****************************************************************************
//*
//*		SetStartPath
//*
//*****************************************************************************
void CGameSpellView::SetStartPath(LPCTSTR pPath)
{


	m_sPicOrig = m_sPicPath;
	m_sPicPath = pPath;

	DelBackSlash(m_sPicPath);

}



//*****************************************************************************
//*
//*		StartSound
//*
//*****************************************************************************
void CGameSpellView::StartSound(short *pData,unsigned uLen)
{
UINT	uIdx;



	if(!pData || !uLen || uLen>0x40000000)return;


	for(uIdx=0;uIdx<4;uIdx++)
		{
		if(m_aPlayLen[uIdx])continue;

		m_aPlay   [uIdx] = pData;
		m_aPlayLen[uIdx] = uLen;

		break;
		}


}

//*****************************************************************************
//*
//*		StartSound
//*
//*****************************************************************************
void CGameSpellView::StartSound(LPCTSTR pSound)
{
DWORD		dwThread;
HANDLE		hThread;


	hThread = CreateThread(NULL,0x8000,WaveThread,(void*)pSound,0,&dwThread);
	CloseHandle(hThread);

}

//*****************************************************************************
//*
//*		WaveThread
//*
//*****************************************************************************
DWORD WINAPI CGameSpellView::WaveThread(LPVOID pParam)
{
LPCTSTR		pName=(LPCTSTR)pParam;
unsigned	uDiff;
unsigned	uTick;


	if(!strncmp(pName,"CLING",5))
		{
		uTick	= GetTickCount();
		uDiff	= uTick-m_uLastCling;
		if(uDiff<280)Sleep(280-uDiff);
		m_uLastCling = GetTickCount();
		}

return PlaySound(pName,AfxGetInstanceHandle(),SND_RESOURCE|SND_ASYNC);
}

//*****************************************************************************
//*
//*		OnNewTextUI
//*
//*****************************************************************************
void CGameSpellView::OnNewTextUI(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(1);

}

//*****************************************************************************
//*
//*		OnUseImage?UI
//*
//*****************************************************************************
void CGameSpellView::OnUseImageAUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iStarSize==2);}
void CGameSpellView::OnUseImageBUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iStarSize==1);}
void CGameSpellView::OnUseImageCUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iStarSize==0);}
void CGameSpellView::OnUseImageDUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iStarSize==3);}

//*****************************************************************************
//*
//*		OnPicPath
//*
//*****************************************************************************
void CGameSpellView::OnPicPath()
{
CPathDlg	sDlg;



	sDlg.SetTitle("Pfad mit Texten");
	sDlg.SetPath((m_sPicOrig.IsEmpty())? m_sPicPath:m_sPicOrig);

	if(sDlg.DoModal()!=IDOK)return;

	m_sPicOrig.Empty();
	m_sPicPath = sDlg.GetPath();
	DelBackSlash(m_sPicPath);


}

//*****************************************************************************
//*
//*		OnPicTime
//*
//*****************************************************************************
void CGameSpellView::OnPicTime()
{
CValueDlg	sDlg;



	sDlg.SetTitle("Schaltzeit einstellen");
	sDlg.SetTextTitle("Weiterschaltzeit in Millisekunden (2000...10000) :");
	sDlg.SetValue(m_uSwitchTime);

	if(sDlg.DoModal()!=IDOK)return;

	m_uSwitchTime = sDlg.GetValue();

	if(m_uSwitchTime< 2000)m_uSwitchTime=2000;
	if(m_uSwitchTime>10000)m_uSwitchTime=10000;

	m_uSwitchUsed = m_uSwitchTime;

}

//*****************************************************************************
//*
//*		OnStart/StopUI
//*
//*****************************************************************************
void CGameSpellView::OnStartUI(CCmdUI *pCmdUI){pCmdUI->Enable(m_bRunning==0 && m_aBgNum[0]!=2 && m_aBgNum[1]!=2);}
void CGameSpellView::OnResetUI(CCmdUI *pCmdUI){pCmdUI->Enable(m_aStop[1]!=0 || m_aStop[0]!=0 || m_aBgNum[0]==2 || m_aBgNum[1]==2);}
void CGameSpellView::OnStop1UI(CCmdUI *pCmdUI){pCmdUI->Enable(m_bRunning!=0 && m_aStop[0]==0);}
void CGameSpellView::OnStop2UI(CCmdUI *pCmdUI){pCmdUI->Enable(m_bRunning!=0 && m_aStop[1]==0);}
void CGameSpellView::OnStop1Ex(CCmdUI *pCmdUI){pCmdUI->Enable(m_bRunning!=0 && m_aStop[0]==0 && m_aStop[1]==0);}
void CGameSpellView::OnStop2Ex(CCmdUI *pCmdUI){pCmdUI->Enable(m_bRunning!=0 && m_aStop[0]==0 && m_aStop[1]==0);}

//*****************************************************************************
//*
//*		OnSelComPort
//*
//*****************************************************************************
void CGameSpellView::OnSelComPort()
{
char		cText[32];
int			iPort;
CTextDlg	sDlg;


	sprintf(cText,"COM%i",m_iPort+1);

	sDlg.SetText(cText);
	sDlg.SetTitle("COM-Port");
	sDlg.SetTextTitle("Bitte hier das COM-Port angeben :");
	if(sDlg.DoModal()!=IDOK)return;

	sDlg.GetText(cText,sizeof(cText));

	if(memicmp(cText,"COM",3))
		{
		iPort = strtoi(cText);
		}
	else{
		iPort = strtoi(cText+3);
		}

	m_iPort = (iPort<=0)? 0:iPort-1;

}

//*****************************************************************************
//*
//*		OnNextGame
//*
//*****************************************************************************
void CGameSpellView::OnNextGame()
{
int			iNum;
CValueDlg	sDlg;


	sDlg.SetValue(m_uGameNumber+1);
	sDlg.SetTitle("Nchstes Spiel");
	sDlg.SetTextTitle("Bitte hier die Spielnummer eingeben :");
	if(sDlg.DoModal()!=IDOK)return;

	iNum = sDlg.GetValue()-1;

	if(iNum>=0 && iNum<1000 && (iNum^m_uGameNumber))
		{
		m_uGameNumber = iNum;
		}

}

//*****************************************************************************
//*
//*		OnReset
//*
//*****************************************************************************
void CGameSpellView::OnReset()
{
	Reset();
}


//*****************************************************************************
//*
//*		OnStart
//*
//*****************************************************************************
void CGameSpellView::OnStart()
{
	Start();
}

//*****************************************************************************
//*
//*		OnStop1
//*
//*****************************************************************************
void CGameSpellView::OnStop1()
{
	Stop(0);
}

//*****************************************************************************
//*
//*		OnStop2
//*
//*****************************************************************************
void CGameSpellView::OnStop2()
{
	Stop(1);
}

//*****************************************************************************
//*
//*		Start
//*
//*****************************************************************************
void CGameSpellView::Start()
{
unsigned	uTurn;


	if(m_bRunning    )return;
	if(m_aBgNum[0]==2)return;
	if(m_aBgNum[1]==2)return;


	for(uTurn=0;;uTurn++)
		{
		if(uTurn>=10)
			{
			strcpy(m_aTextInfo,"Keine Spiele mehr !");
			strcpy(m_aTextMain,"Keine Spiele mehr !");
			m_iInfoDraw = 1;
			return;
			}

		m_uGameNumber++;	

		if(LoadGame(m_uGameNumber))
			{
			break;
			}
		}

	m_uStartTick = GetTickCount();
	m_uTimerTick = m_uStartTick;	
	m_iInfoDraw	 = 1;
	m_bRunning	 = 1;


}

//*****************************************************************************
//*
//*		Stop
//*
//*****************************************************************************
void CGameSpellView::Stop(unsigned uPlace)
{

	if(uPlace>=2)return;
	if(m_aStop[uPlace^1])return;

	m_aStop [uPlace] = 1;
	m_aBgNum[uPlace] = 1;

	if(uPlace)StartSound("CLING2");
	else	  StartSound("CLING1");

}

//*****************************************************************************
//*
//*		Reset
//*
//*****************************************************************************
void CGameSpellView::Reset()
{

	memset(m_aTextUp,1,sizeof(m_aTextUp));
	m_iTextCount = 0;
	m_iTextDraw	 = 1;

	m_bRunning   = 0;
	m_aStop [0]  = 0;
	m_aStop [1]  = 0;
	m_aBgNum[0]  = 0;
	m_aBgNum[1]  = 0;
}


//*****************************************************************************
//*
//*		SetZoom
//*
//*****************************************************************************
void CGameSpellView::SetZoom(int iZoom)
{

	m_iZoom = iZoom;

	GetWindowRect(&m_sWndRect);
	m_sWndRect.right--;

}

//*****************************************************************************
//*
//*		OnStarAdd1
//*
//*****************************************************************************
void CGameSpellView::OnStarAdd1()
{
	m_aPoints[0] = (m_aPoints[0]+1)%m_iStarMax;
}

//*****************************************************************************
//*
//*		OnStarAdd2
//*
//*****************************************************************************
void CGameSpellView::OnStarAdd2()
{
	m_aPoints[1] = (m_aPoints[1]+1)%m_iStarMax;
}

//*****************************************************************************
//*
//*		OnStarSub1
//*
//*****************************************************************************
void CGameSpellView::OnStarSub1()
{
	m_aPoints[0] = (m_aPoints[0]+m_iStarMax-1)%m_iStarMax;
}

//*****************************************************************************
//*
//*		OnStarSub2
//*
//*****************************************************************************
void CGameSpellView::OnStarSub2()
{
	m_aPoints[1] = (m_aPoints[1]+m_iStarMax-1)%m_iStarMax;
}


//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CGameSpellView::OnTimer(UINT_PTR nIdEvent)
{
static BOOL		bLocked=0;
BitmapImage	   *pImage;
LPCTSTR			pState;
LPCTSTR			pText;
DWORD			uTick;
DWORD			uDiff;
CPoint			sPoint;
UINT			uColor;
char 			cChar;
char			cFlag;
int				iPixel;
int				iWidth;
int				iPicX;
int				iPicY;
int				iOffX;
int				iOffY;
int				iAddX;
int				iAddY;
int				iLine;
int				iPos;
int				iRow;
int				iNum;
int				iCol;



	if(nIdEvent==IDC_UPDATE)
		{
		if(!m_iWndSizeX || !m_iWndSizeY)
			{
			return;
			}

		if(bLocked)return;

		bLocked = TRUE;

		if(m_iZoom==2)										// Cursor weg schieben bei Zoom
			{
			GetCursorPos(&sPoint);

			if(m_sWndRect.PtInRect(sPoint))
				{
				SetCursorPos(m_sWndRect.right,m_sWndRect.bottom-1);
				}
			}



		cFlag	= 0;
		uTick	=  GetTickCount();
		pImage	=  m_cBitmapWnd.GetImage();


		if(!m_aStop[0] && !m_aStop[1] && m_bRunning)
			{
			uDiff = uTick-m_uStartTick;
			
			if(uDiff>=m_uSwitchUsed)						// Einen weiten Buchstaben aufdecken
				{
				if(m_iTextCount>0 && m_iTextLines>0)
					{
					iNum = rand()%m_iTextCount;

					for(iPos=0;;iPos++)
						{
						if(m_aTextUp[iPos])continue;
						
						if(iNum>0)
							{
							iNum--;
							continue;
							}

						m_aTextUp[iPos] = 1;
						m_iTextCount--;
															// In welcher Zeile ist der Buchstabe
						for(iLine=0;iLine<m_iTextLines-1;iLine++)
							{
							if(iPos<m_aTextPlace[iLine+1])break;
							}

						iOffY	= m_iCharPosY+m_iCharSizeY*iLine;
						pText	= m_aTextMain+m_aTextPlace[iLine];
						iNum	= m_aTextSizes[iLine];
						iOffX	= m_iCharPosX-m_iCharSizeX*(iNum/2);

						if(iNum&1)iOffX-=m_iCharSizeX/2;

						iPos   -= m_aTextPlace[iLine];
						iOffX  += m_iCharSizeX*iPos;

						pImage->Box(iOffX,iOffY,m_iCharSizeX,m_iCharSizeY,BACK_COLOR);
						DrawChar(pImage,iOffX,iOffY,pText[iPos],TEXT_COLOR);

						m_cBitmapWnd.InvalidateRect(iOffX,iOffY,m_iCharSizeX,m_iCharSizeY);

						break;
						}
					}

				if(m_iTextCount<=0)							// Alles aufgeteckt
					{
					StartSound("ERROR");
					Reset();
					m_aBgNum[0] = 2;
					m_aBgNum[1] = 2;
					}
				else{
					StartSound("TICK");
					}

				m_uStartTick += m_uSwitchUsed;
				cFlag = 1;
				}
	 		}


		if(!m_aStop[0] && !m_aStop[1] && m_bRunning)		// Ton fr Sekunden Zhler
			{
			uDiff = uTick-m_uTimerTick;

			if(uDiff>=1000)									
				{
				if(!cFlag && m_iSecTicker)
					{
					StartSound("TUCK");
					}

				m_uTimerTick += 1000;
				}
			}


		iOffX	= 0;
		iOffY	= m_iWndSizeY-m_iStarY;
		iPicX	= m_iStarX/m_iStarRows;
		iPicY	= m_iStarY;

		for(iPos=0;iPos<16*m_iStarRows;iPos++)				// Linke Sterne	zeichnen
			{
			iNum = (m_aPoints[0]<=(UINT)iPos)? 0:1;
			iCol =  m_aBgNum [0];
			iRow =  iPos%m_iStarRows;

			if(iNum!=m_aStars[iPos*2+0] || iCol!=m_aStars[60])
				{
				m_aStars[iPos*2+0] = iNum;

				pImage->Box(iOffX,iOffY,iPicX,iPicY,m_aHgColors[iCol]);

				if(iNum)
					{
					iAddX = (iPicX-m_sStarImg.Width ())/2;
					iAddY = (iPicY-m_sStarImg.Height())/2;
					pImage->PutAlpha(m_sStarImg,iOffX+iAddX,iOffY+iAddY);
					}

				m_cBitmapWnd.InvalidateRect(iOffX,iOffY,iPicX,iPicY);
				}

			if(iRow+1>=m_iStarRows)
				{
				iOffY -= iPicY;
				iOffX -= iPicX*(m_iStarRows-1); 
				}
			else{
				iOffX += iPicX;
				}
			}


		iOffX	= m_iWndSizeX-m_iStarX;
		iOffY	= m_iWndSizeY-m_iStarY;
		iPicX	= m_iStarX/m_iStarRows;
		iPicY	= m_iStarY;

		for(iPos=0;iPos<16*m_iStarRows;iPos++)				// Rechte Sterne zeichnen
			{
			iNum = (m_aPoints[1]<=(UINT)iPos)? 0:1;
			iCol =  m_aBgNum [1];
			iRow =  iPos%m_iStarRows;

			if(iNum!=m_aStars[iPos*2+1] || iCol!=m_aStars[61])
				{
				m_aStars[iPos*2+1] = iNum;

				pImage->Box(iOffX,iOffY,iPicX,iPicY,m_aHgColors[iCol]);

				if(iNum)
					{
					iAddX = (iPicX-m_sStarImg.Width ())/2;
					iAddY = (iPicY-m_sStarImg.Height())/2;
					pImage->PutAlpha(m_sStarImg,iOffX+iAddX,iOffY+iAddY);
					}

				m_cBitmapWnd.InvalidateRect(iOffX,iOffY,iPicX,iPicY);
				}

			if(iRow+1>=m_iStarRows)
				{
				iOffY -= iPicY;
				iOffX -= iPicX*(m_iStarRows-1); 
				}
			else{
				iOffX += iPicX;
				}
			}

		if(m_uHgOk!=0)										// Rahmen zeichnen
			{
			m_uHgOk = 0;

			pImage->Box(m_iStarX+0,0,1,m_iWndSizeY,BGR(222,222,222));
			pImage->Box(m_iStarX+1,0,1,m_iWndSizeY,BGR(188,188,188));
			pImage->Box(m_iStarX+2,0,2,m_iWndSizeY,BGR(133,133,133));
			pImage->Box(m_iStarX+4,0,1,m_iWndSizeY,BGR( 88, 88, 88));
			pImage->Box(m_iStarX+5,0,1,m_iWndSizeY,BGR( 44, 44, 44));

			m_cBitmapWnd.InvalidateRect(m_iStarX,0,6,m_iWndSizeY);

			pImage->Box(m_iWndSizeX-6-m_iStarX+0,0,1,m_iWndSizeY,BGR(222,222,222));
			pImage->Box(m_iWndSizeX-6-m_iStarX+1,0,1,m_iWndSizeY,BGR(188,188,188));
			pImage->Box(m_iWndSizeX-6-m_iStarX+2,0,2,m_iWndSizeY,BGR(133,133,133));
			pImage->Box(m_iWndSizeX-6-m_iStarX+4,0,1,m_iWndSizeY,BGR( 88, 88, 88));
			pImage->Box(m_iWndSizeX-6-m_iStarX+5,0,1,m_iWndSizeY,BGR( 44, 44, 44));

			m_cBitmapWnd.InvalidateRect(m_iWndSizeX-6-m_iStarX,0,6,m_iWndSizeY);
			}

		m_aStars[60] = m_aBgNum[0];
		m_aStars[61] = m_aBgNum[1];


		if(m_iInfoDraw)										// Infotext ausgeben
			{
			m_iInfoDraw = 0;

			iWidth = m_iWndSizeX-(m_iStarX+FRAME_SIZE)*2;

			pImage->Box(m_iStarX+FRAME_SIZE,0, iWidth ,TEXT_LINE-6,BGR(  0,  0,  0));
			pImage->Box(m_iStarX+FRAME_SIZE,TEXT_LINE-6+0,iWidth,1,BGR(222,222,222));
			pImage->Box(m_iStarX+FRAME_SIZE,TEXT_LINE-6+1,iWidth,1,BGR(188,188,188));
			pImage->Box(m_iStarX+FRAME_SIZE,TEXT_LINE-6+2,iWidth,2,BGR(133,133,133));
			pImage->Box(m_iStarX+FRAME_SIZE,TEXT_LINE-6+4,iWidth,1,BGR( 88, 88, 88));
			pImage->Box(m_iStarX+FRAME_SIZE,TEXT_LINE-6+5,iWidth,1,BGR( 44, 44, 44));

			pImage->SetFont(m_aFont);
			pImage->SetAlign(1);
			pImage->SetPixelFunction(TEXT_NONE ,0,1);
			pImage->SetPixelFunction(TEXT_SMOTH,BGR(0,255,0),0);
			iPixel = pImage->Print(0,BI_TETXSIZE,m_aTextInfo);

			if(iPixel>iWidth-8)								// Kleineren Font benutzen
				{
				pImage->SetFont(m_aFontX);
				iPixel = pImage->Print(0,BI_TETXSIZE,m_aTextInfo);

				if(iPixel>iWidth-8)
					{
					pImage->SetFont(m_aFontS);
					pImage->Print(m_iStarX+FRAME_SIZE+iWidth/2,(TEXT_LINE-20)/2,m_aTextInfo);
					}
				else{
					pImage->Print(m_iStarX+FRAME_SIZE+iWidth/2,(TEXT_LINE-32)/2,m_aTextInfo);
					}
				}
			else{
				pImage->Print(m_iStarX+FRAME_SIZE+iWidth/2,(TEXT_LINE-40)/2,m_aTextInfo);
				}


			m_cBitmapWnd.InvalidateRect(m_iStarX+FRAME_SIZE,0,iWidth,TEXT_LINE);
			}

		if(m_iTextDraw)										// Den ganzen Text neuzeichnen
			{
			m_iTextDraw = 0;

			m_iTxtSizeX = m_iWndSizeX-(m_iStarX+FRAME_SIZE)*2;
			m_iTxtSizeY = m_iWndSizeY-TEXT_LINE;

			pImage->Box(m_iStarX+FRAME_SIZE,TEXT_LINE,m_iTxtSizeX,m_iTxtSizeY,BACK_COLOR);

			if(m_iTextMax>0)
				{
				   m_iCharSizeX = (m_iTxtSizeX-40)/m_iTextMax;
				if(m_iCharSizeX<10)m_iCharSizeX=10;
				if(m_iCharSizeX>64)m_iCharSizeX=64;
				}
			else{
				m_iCharSizeX = 10;
				}

			m_iCharSizeY = (m_iCharSizeX*100)/56;
			m_iLineSizeY =  m_iCharSizeY+m_iCharSizeY/2;
	
			m_iCharPosX	 = m_iWndSizeX/2;
			iNum		 = m_iTxtSizeY-m_iLineSizeY*m_iTextLines+m_iCharSizeY/2;
			iNum		-= m_sPicImage.Height();   

			if(iNum<30)iNum=30;

			iNum		/= 3;

			m_iCharPosY	 = TEXT_LINE+iNum;

			if(m_sPicImage.IsOk())							// Das Bild ausgeben
				{
				iPicX	= m_iWndSizeX/2-m_sPicImage.Width()/2;
				iPicY	= m_iCharPosY+m_iLineSizeY*m_iTextLines-m_iCharSizeY/2;
				iPicY  += iNum;

				if(m_sPicImage.HasAlpha())
					{
					pImage->PutAlpha(m_sPicImage,iPicX,iPicY);
					}
				else{
					pImage->Put(m_sPicImage,iPicX,iPicY);
					}
				}


			iOffY	= m_iCharPosY;
															// Buchstaben ausgeben
			for(iLine=0;iLine<m_iTextLines;iLine++,iOffY+=m_iCharSizeY)
				{
				pState	= m_aTextUp  +m_aTextPlace[iLine];
				pText	= m_aTextMain+m_aTextPlace[iLine];
				iNum	= m_aTextSizes[iLine];
				iOffX	= m_iCharPosX-m_iCharSizeX*(iNum/2);

				if(iNum&1)iOffX-=m_iCharSizeX/2;

				for(iPos=0;iPos<iNum;iPos++,iOffX+=m_iCharSizeX)
					{
					uColor = (pState[iPos])? TEXT_COLOR:HIDE_COLOR;
					cChar  = (pState[iPos])? pText[iPos]:'*';

					DrawChar(pImage,iOffX,iOffY,cChar,uColor);
					}
				}


			m_cBitmapWnd.InvalidateRect(m_iStarX+FRAME_SIZE,TEXT_LINE,m_iTxtSizeX,m_iTxtSizeY);
			}
		


		bLocked = FALSE;

		return;
		}

	CView::OnTimer(nIdEvent);
}


//*****************************************************************************
//*
//*		DrawChar
//*
//*****************************************************************************
void CGameSpellView::DrawChar(BitmapImage *pImage,int iPosX,int iPosY,char cSign,unsigned uColor)
{
BitmapImage		sImage;
BitmapImage		sPrime;
HDC				hCharDc;
unsigned		uSizeX;
unsigned		uSizeY;
unsigned		uPosX;
unsigned		uPosY;
unsigned 		uRet;	



	if(cSign==' ' || cSign=='\t')return;	
	
	sImage.SetSize(1,256,256,0,BI_BITMAP); 
	hCharDc = CreateCompatibleDC(NULL);

	SelectObject(hCharDc,sImage.GetBitmap());
	SelectObject(hCharDc,m_sTextFont.m_hObject);
	SetTextColor(hCharDc,RGB(255,255,255));
	SetBkColor	(hCharDc,RGB(  0,  0,  0));
	SetBkMode	(hCharDc,TRANSPARENT);

	uRet	= TabbedTextOut(hCharDc,0,0,&cSign,1,0,NULL,0);
	uSizeX	= (WORD)uRet;
	uSizeY	= uRet>>16;


	uColor |= 0xFF000000;
	sPrime.SetSize(32,uSizeX,uSizeY);

	for(uPosY=0;uPosY<uSizeY;uPosY++)
	for(uPosX=0;uPosX<uSizeX;uPosX++)
		{
		if(!sImage.GetPixel(uPosX,uPosY))
			{
			continue;
			}

		sPrime.SetPixel(uPosX,uPosY,uColor);
		}

	sPrime.Stretch(m_iCharSizeX,m_iCharSizeY,1);


	pImage->PutAlpha(sPrime,iPosX,iPosY);
	
	DeleteDC(hCharDc);	

}

//*****************************************************************************
//*
//*		ComThread
//*
//*****************************************************************************
DWORD WINAPI CGameSpellView::ComThread(LPVOID pParam)
{
CGameSpellView *pThis=(CGameSpellView*)pParam;
char			aData[33];
static int		aLastPush[8];
int				iHandle=-1;
int				iValue;
int				iFlag;
int				iPort;
int				iDiff;
int				iPin;
int				iPos;
int				iOff;


	iPort = -1;
	iPos  =  0;

	while(!pThis->m_iStop)
		{
		if(iPort!=pThis->m_iPort || !ComCheckPort(iHandle))
			{
			ComClose(iHandle);
			iPort   = pThis->m_iPort;
			iHandle = ComOpen(iPort,9600);
			}

		if(iHandle<0)
			{
			Sleep(200);
			continue;
			}

		for(iOff=0;iOff<iPos;iOff++)
			{
			if(!strwchar(aData[iOff],0x00040001))
				{
				continue;
				}

			if(iOff+1<iPos)
				{
				if(aData[iOff+1]!='U')
				if(aData[iOff+1]!='S')
				if(aData[iOff+1]!='D')continue;
				}

			break;
			}

		if(iOff>0)
			{
			iPos -= iOff;
			memmove(aData,aData+iOff,iPos);
			}

		aData[iPos] = 0;
		iFlag		= 0;

		while(iPos>=3)
			{
			iOff = strwlen(aData+2,0x00040001);

			if(iOff>8)
				{
				iOff += 2;
				iPos -= iOff;
				memmove(aData,aData+iOff,iPos);
				iFlag=1;
				break;
				}


			if(iOff<8)
				{
				if(iOff+2==iPos)break;

				iOff += 2;
				iPos -= iOff;
				memmove(aData,aData+iOff,iPos);
				iFlag=1;
				break;
				}

			if(iOff==8 && iPos==10)
				{
				break;
				}

			if(iOff==8 && aData[10]!='\r' && aData[10]!='\n')
				{
				iOff += 2;
				iPos -= iOff;
				memmove(aData,aData+iOff,iPos);
				iFlag=1;
				break;
				}

			iPin = aData[0]-'0';
			iValue = GetTickCount();

			if(aData[1]=='D' && iPin<8)
				{
				   iDiff = iValue-aLastPush[iPin];
				if(iDiff<0 || iDiff>100)
					{
					aLastPush[iPin] = iValue;

					switch(iPin)
						{
					case 0:	pThis->Stop(0);
							break;

					case 1:	pThis->Stop(1);
							break;

					case 2:	pThis->PostMessage(WM_COMMAND,ID_START);
							break;

					case 3:	pThis->PostMessage(WM_COMMAND,ID_RESET);
							break;

					case 4:	pThis->PostMessage(WM_COMMAND,ID_STARSUB1);
							break;

					case 5:	pThis->PostMessage(WM_COMMAND,ID_STARADD1);
							break;

					case 6:	pThis->PostMessage(WM_COMMAND,ID_STARSUB2);
							break;

					case 7:	pThis->PostMessage(WM_COMMAND,ID_STARADD2);
							break;
						}

					/*
					if(iPin==4)
						{
						iDiff = iValue-pThis->m_uLastZoom;

						if(iDiff<0 || iDiff>100)
							{
							pThis->m_uLastZoom = iValue;
							pThis->PostMessage(WM_COMMAND,ID_ZOOM);
							}
						}
					*/
					}
				}

			if(aData[11]!='\n')iOff++;

			iOff += 2;
			iPos -= iOff;

			if(iPos<0 || iPos>32)iPos=0;

			memmove(aData,aData+iOff,iPos);

			if(iPos>=3)
				{
				if(aData[0]<'0'){iFlag=1;break;}
				if(aData[0]>'7'){iFlag=1;break;}
				if(aData[iOff+1]!='U')
				if(aData[iOff+1]!='S')
				if(aData[iOff+1]!='D'){iFlag=1;break;}
				}
			}

		if(iFlag)continue;


		ComWaitUntilResv(iHandle,100);
		iOff = ComGetReadCount(iHandle);
		if(iOff<=0)
			{
			if(iOff==0)continue;
			iPort=-1;
			continue;
			}

		if(iPos+iOff>32)iOff=32-iPos;
		iOff = ComRead(iHandle,aData+iPos,iOff);
		if(iOff<=0)
			{
			if(iOff==0)continue;
			iPort=-1;
			continue;
			}

		iPos += iOff;
		aData[iPos] =0;
		}


	ComClose(iHandle);
	pThis->m_iDone = 1;


return 0;
}

//*****************************************************************************
//*
//*		OnSecTickerUI
//*
//*****************************************************************************
void CGameSpellView::OnSecTickerUI(CCmdUI *pCmdUI)
{

	pCmdUI->SetCheck(m_iSecTicker!=0);

}


//*****************************************************************************
//*
//*		OnSecTicker
//*
//*****************************************************************************
void CGameSpellView::OnSecTicker()
{

	m_iSecTicker = !m_iSecTicker;

}

//*****************************************************************************
//*
//*		OnUseImage?
//*
//*****************************************************************************
void CGameSpellView::OnUseImageA(){UseImage(2);}
void CGameSpellView::OnUseImageB(){UseImage(1);}
void CGameSpellView::OnUseImageC(){UseImage(0);}
void CGameSpellView::OnUseImageD(){UseImage(3);}


//*****************************************************************************
//*
//*		UseImage
//*
//*****************************************************************************
//	Eine neue Gre der Sterne einstellen
//	iMode		: Gre der Sterne (0=gro 1=mittel 2=klein 3=Zwei-Reihen)
void CGameSpellView::UseImage(int iMode)
{

	m_iStarSize = iMode;
	SelectStar(m_iStarSize);

	memset(m_aStars,0xFF,sizeof(m_aStars));
	m_uHgOk		  = 0xFF;
	m_iInfoDraw	  = 1;
	m_iTextDraw	  = 1;

	m_cBitmapWnd.RedrawWindow();

}

//*****************************************************************************
//*
//*		SelectStar
//*
//*****************************************************************************
//	Eine neue Gre der Sterne einstellen
//	iStar		: Gre der Sterne (0=gro 1=mittel 2=klein 3=Zwei-Reihen)
void CGameSpellView::SelectStar(int iStar)
{

	switch(iStar)
		{
	case 3:	m_sStarImg		= m_sStarImg3;
			m_iStarMax		= MAX_POINTS*3+(MAX_POINTS+1&1);
			m_iStarX		= 136;
			m_iStarY		= 68;
			m_iStarRows		= 2;
			break;

	case 2:	m_sStarImg		= m_sStarImg3;
			m_iStarMax		= MAX_POINTS;
			m_iStarX		= 68;
			m_iStarY		= 68;
			m_iStarRows		= 1;
			break;

	case 1:	m_sStarImg		= m_sStarImg2;
			m_iStarMax		= MAX_POINTS;
			m_iStarX		= 102;
			m_iStarY		= 102;
			m_iStarRows		= 1;
			break;

	default:m_sStarImg		= m_sStarImg1;
			m_iStarMax		= MAX_POINTS;
			m_iStarX		= 136;
			m_iStarY		= 136;
			m_iStarRows		= 1;
			break;
		}

}

//*****************************************************************************
//*
//*		LoadGame
//*
//*****************************************************************************
int CGameSpellView::LoadGame(int iIndex)
{
char			cBuffer[0x10000];
LPCTSTR			pText;
CStringChain	sList;
CString			sPath;
int				iPos;
int				iLen;
int				iAdd;


	m_uSwitchUsed = m_uSwitchTime;

	
	sprintf(cBuffer,"\\Game%03i\\Pic.png",iIndex);

	sPath  = m_sPicPath;
	sPath += cBuffer;

	ImageLoader(sPath,&m_sPicImage);

	sprintf(cBuffer,"\\Game%03i\\Game.txt",iIndex);

	sPath  = m_sPicPath;
	sPath += cBuffer;

	if(LoadMemory(sPath,cBuffer,sizeof(cBuffer))<=0)
		{
		return 0;
		}

	iLen = strcwlen(cBuffer,0x40);


	if(cBuffer[iLen])										// Ist ein Text vorhanden			
		{
		iPos  = iLen+1;
		iPos += strwlen (cBuffer+iPos,0x40);
		cBuffer[iLen] = 0;
	
		
		for(;;)												// Antworten laden
			{		
			iLen  = strcwlen(cBuffer+iPos     ,0x40);
			iAdd  = strwlen (cBuffer+iPos+iLen,0xE0);

			if(cBuffer[iPos+iLen+iAdd]==0)
				{
				sList.Add(iLen,cBuffer+iPos);
				break;
				}

			sList.Add(iLen,cBuffer+iPos);
			iPos += iLen+iAdd;		
			}		
		
		
		iPos = rand()%sList.Count();
		
		
		m_uSwitchUsed = m_uSwitchTime;
		pText = sList[iPos];
		
		if(*pText=='@')										// Schaltzeit aus Textholen
			{
			m_uSwitchUsed = atoi(pText+1);

			if(m_uSwitchUsed< 1000)m_uSwitchUsed=1000;
			if(m_uSwitchUsed>10000)m_uSwitchUsed=10000;
			
			pText += 1;
			pText += strwlen(pText,0x01);
			pText += strwlen(pText,0xA0);
			}
		
		strlcpy(m_aTextMain,pText,sizeof(m_aTextMain));
		

		m_iTextLines = 0;
		m_iTextCount = 0;	
		m_iTextMax	 = 0;

		memset(m_aTextUp,0,sizeof(m_aTextUp));

		for(iPos=0;m_aTextMain[iPos];iPos++)				// Zhle Buchstaben
			{
			if(strwchar(m_aTextMain[iPos],0x30000007))
				{
				m_iTextCount++;
				}
			else{
				m_aTextUp[iPos] = 1;				
				}
			}
		
		for(iPos=0;m_aTextMain[iPos];)
			{
			m_aTextPlace[m_iTextLines] = iPos;
			m_aTextSizes[m_iTextLines] = strchar(m_aTextMain+iPos,'|');  

			if(m_iTextMax<m_aTextSizes[m_iTextLines])
				{
				m_iTextMax = m_aTextSizes[m_iTextLines];
				}

			iPos += m_aTextSizes[m_iTextLines];
			if(m_aTextMain[iPos]=='|')iPos++;
			m_iTextLines++;
			
			if(m_iTextLines>=4)break;
			}
		}
	else{													// Kein Text geladen
		m_aTextMain[0] = 0;
		m_iTextLines   = 0; 
		m_iTextCount   = 0;	
		m_iTextMax	   = 0;
		}

	strlcpy(m_aTextInfo,cBuffer,sizeof(m_aTextInfo));

	m_iTextDraw = 1;



return 1;
}




//*****************************************************************************
//*
//*		OnNewText
//*
//*****************************************************************************
void CGameSpellView::OnNewText()
{
static CNewPicDlg	sDlg;
char				cBuffer[4096];
char				cPath[MAX_PATH];
char				cTemp[MAX_PATH];
int					iPos;
int					iLen;


	   sDlg.m_iNumber	= m_uGameNumber;
	if(sDlg.m_iNumber<0)sDlg.m_iNumber=1;

	if(sDlg.DoModal()!=IDOK)return;

	SetCursor(IDC_WAIT);


	switch(sDlg.m_iMode)						
		{													
	case 0:													// Nchster freier Platz

			if(sDlg.m_iNumber<1)sDlg.m_iNumber=1;

			for(;sDlg.m_iNumber<1000;sDlg.m_iNumber++)
				{
				sprintf(cPath,"%s\\Game%03i\\Game.txt",(LPCTSTR)m_sPicPath,sDlg.m_iNumber);
				if(ExistFile(cPath)!=1)break;
				}

			break;

	case 1:													// Einfgen

			if(sDlg.m_iNumber<1)sDlg.m_iNumber=1;

			sprintf(cPath,"%s\\Game%03i\\Game.txt",(LPCTSTR)m_sPicPath,sDlg.m_iNumber);
			if(ExistFile(cPath)!=1)break;

			for(iPos=sDlg.m_iNumber;iPos<1000;iPos++)
				{
				sprintf(cPath,"%s\\Game%03i\\Game.txt",(LPCTSTR)m_sPicPath,iPos);
				if(ExistFile(cPath)!=1)break;
				}

			if(iPos>=1000)									// Kein freier Platz
				{
				MessageBox("Es wurde kein freier Platz gefunden !","Fehler",MB_OK|MB_ICONERROR);
				return;
				}

			for(;iPos>sDlg.m_iNumber;iPos--)
				{
				sprintf(cPath,"%s\\Game%03i\\Game.txt",(LPCTSTR)m_sPicPath,iPos  );
				sprintf(cTemp,"%s\\Game%03i\\Game.txt",(LPCTSTR)m_sPicPath,iPos-1);

				if(!MoveFile(cTemp,cPath))
					{
					MessageBox("Es gab einen Fehler beim Einfgen !","Fehler",MB_OK|MB_ICONERROR);
					return;
					}
				}

			break;
		}


	if(sDlg.m_iNumber>=1000 || sDlg.m_iNumber<1)			// Bildnummer prfen
		{
		MessageBox("Die Bildenummer ist falsch (1..999) !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}


	sprintf(cTemp,"%s\\Game%03i",(LPCTSTR)m_sPicPath,sDlg.m_iNumber);
	sprintf(cPath,"%s\\Game%03i\\Pic.png",(LPCTSTR)m_sPicPath,sDlg.m_iNumber);

	CreatePath(cTemp);

	if(!sDlg.m_sPath.IsEmpty())
		{
		if(ImageLoader(sDlg.m_sPath,&m_sPicImage))			// Neues Bild laden
			{
			MessageBox("Das Bild konnte nicht geladen werden !","Fehler",MB_OK|MB_ICONERROR);
			return;
			}

		if(sDlg.m_sPath!=cPath)
			{
			if(ImageSaver(cPath,&m_sPicImage))
				{
				MessageBox("Es gab einen Fehler beim Speichern des Bildes !","Fehler",MB_OK|MB_ICONERROR);
				return;
				}
			}
		}

	sprintf(cPath,"%s\\Game%03i\\Game.txt",(LPCTSTR)m_sPicPath,sDlg.m_iNumber);
	iLen = sprintf(cBuffer,"%s\n%s\n",(LPCTSTR)sDlg.m_sText,(LPCTSTR)sDlg.m_sInfo);
	SaveMemory(cPath,cBuffer,iLen);

	LoadGame(sDlg.m_iNumber);

	m_bRunning		= 0;
	m_uGameNumber   = sDlg.m_iNumber;
	m_uStartTick	= GetTickCount();
	m_uTimerTick	= m_uStartTick;
	m_iInfoDraw		= 1;
	m_iTextDraw		= 1;
	m_bRunning		= 1;

	OnTimer(IDC_UPDATE);
	RedrawWindow();

}


