//*****************************************************************************
//*
//*
//*		GameSpellView.h
//*
//*
//*****************************************************************************
#ifndef		AFX_GAMESPELLVIEW_H__77743167_0938_40FE_A1F4_64E3F5A18C4B__INCLUDED_
#define		AFX_GAMESPELLVIEW_H__77743167_0938_40FE_A1F4_64E3F5A18C4B__INCLUDED_	

#if _MSC_VER > 1000
#pragma		once						
#endif

#define 	MAX_PT			32
#define 	MAX_POLY		32

class		BitmapImage;		

//*****************************************************************************
//*
//*		Klasse CGameSpellView
//*
//*****************************************************************************
class CGameSpellView : public CView
{
protected:

	CGameSpellView();
	DECLARE_DYNCREATE(CGameSpellView)

public:

	CGameSpellDoc* GetDocument();

	void		 SetZoom(int iZoom);
	void		 UseImage(int iMode);
	void		 Stop (unsigned uPlace);
	void		 SetStartPath(LPCTSTR pPath);
	void		 Start();
	void		 Reset();


	//{{AFX_VIRTUAL(CGameSpellView)
public:
	virtual void OnDraw(CDC* pDC);								// berladen zum Zeichnen dieser Ansicht
	virtual BOOL PreCreateWindow(CREATESTRUCT &sCreate);
protected:
	//}}AFX_VIRTUAL

public:
	virtual ~CGameSpellView();
	#ifdef		_DEBUG					
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext &sDc) const;
	#endif

protected:

	BYTE			m_uHgOk;
	BOOL			m_bRunning;
	BYTE			m_aStars[64];
	BYTE			m_aStop	 [2];
	BYTE			m_aBgNum [2];
	BYTE			m_aPoints[2];
	CBitmapWnd		m_cBitmapWnd;
	static DWORD	m_aHgColors[];
	BitmapImage		m_sStarImg1;
	BitmapImage		m_sStarImg2;
	BitmapImage		m_sStarImg3;
	BitmapImage		m_sStarImg;
	BitmapImage		m_sPicImage;
	BitmapImage		m_sPicPoly;
	CRect			m_sWndRect;
	DWORD			m_uDeltaTick;
	static DWORD	m_uLastCling;
	DWORD			m_uLastTick;
	DWORD			m_uLastZoom;
	DWORD			m_uStartTick;
	DWORD			m_uTimerTick;
	DWORD			m_uGameNumber;
	DWORD			m_uSwitchTime;
	DWORD			m_uSwitchUsed;
	CFont			m_sTextFont;
	CString			m_sPicPath;
	CString			m_sPicOrig;
	char 			m_aTextUp  [256];
	char 			m_aTextInfo[256];
	char 			m_aTextMain[256];
	int				m_aTextSizes[4];
	int				m_aTextPlace[4];
	int				m_iTextLines;
	int				m_iTextCount;
	int				m_iTextDraw;
	int				m_iTextMax;
	int				m_iInfoDraw;
	int				m_iNumberX;
	int				m_iNumberY;
	int				m_iWndSizeX;
	int				m_iWndSizeY;
	int				m_iTxtSizeX;
	int				m_iTxtSizeY;
	int				m_iCharPosX;
	int				m_iCharPosY;
	int				m_iCharSizeX;
	int				m_iCharSizeY;
	int				m_iLineSizeY;
	int				m_iSecTicker;
	int				m_iStarSize;
	int				m_iStarRows;
	int				m_iStarMax;
	int				m_iStarX;
	int				m_iStarY;
	int				m_iZoom;
	int volatile	m_iStop;
	int volatile	m_iDone;
	int volatile	m_iPort;
	static short   *m_pCling1;
	static UINT		m_uCling1Len;
	static HRSRC	m_hCling1Src;
	static HGLOBAL	m_hCling1Hg;
	static short   *m_pCling2;
	static UINT		m_uCling2Len;
	static HRSRC	m_hCling2Src;
	static HGLOBAL	m_hCling2Hg;
	static short   *m_pError;
	static UINT		m_uErrorLen;
	static HRSRC	m_hErrorSrc;
	static HGLOBAL	m_hErrorHg;
	static short   *m_pTuck;
	static UINT		m_uTuckLen;
	static HRSRC	m_hTuckSrc;
	static HGLOBAL	m_hTuckHg;
	static short   *m_pTick;
	static UINT		m_uTickLen;
	static HRSRC	m_hTickSrc;
	static HGLOBAL	m_hTickHg;
	static short   *m_aPlay[4];
	static UINT		m_aPlayLen[4];
	static BYTE		m_aFontS[];
	static BYTE		m_aFontX[];
	static BYTE		m_aFont[];

protected:
	//{{AFX_MSG(CGameSpellView)
	afx_msg int  OnCreate(LPCREATESTRUCT pCreateStruct);
	afx_msg void OnSize(UINT nType,int iSizeX,int iSizeY);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnSecTickerUI(CCmdUI *pCmdUI);
	afx_msg void OnUseImageAUI(CCmdUI *pCmdUI);
	afx_msg void OnUseImageBUI(CCmdUI *pCmdUI);
	afx_msg void OnUseImageCUI(CCmdUI *pCmdUI);
	afx_msg void OnUseImageDUI(CCmdUI *pCmdUI);
	afx_msg void OnNewTextUI(CCmdUI *pCmdUI);
	afx_msg void OnResetUI(CCmdUI *pCmdUI);
	afx_msg void OnStartUI(CCmdUI *pCmdUI);
	afx_msg void OnStop1UI(CCmdUI *pCmdUI);
	afx_msg void OnStop2UI(CCmdUI *pCmdUI);
	afx_msg void OnStop1Ex(CCmdUI *pCmdUI);
	afx_msg void OnStop2Ex(CCmdUI *pCmdUI);
	afx_msg void OnSelComPort();
	afx_msg void OnSecTicker();
	afx_msg void OnUseImageA();
	afx_msg void OnUseImageB();
	afx_msg void OnUseImageC();
	afx_msg void OnUseImageD();
	afx_msg void OnNextGame();
	afx_msg void OnStarAdd1();
	afx_msg void OnStarAdd2();
	afx_msg void OnStarSub1();
	afx_msg void OnStarSub2();
	afx_msg void OnDestroy();
	afx_msg void OnPicPath();
	afx_msg void OnPicTime();
	afx_msg void OnNewText();
	afx_msg void OnStart();
	afx_msg void OnStop1();
	afx_msg void OnStop2();
	afx_msg void OnReset();
	//}}AFX_MSG

	virtual void OnUpdate(CView *pSender,LPARAM lHint,CObject *pHint);

	void		 SelectStar(int iStar);
	int			 LoadGame(int iIndex);
	void		 StartDraw(int iFixed,CPoint sPoint);
	void		 StartSound(LPCTSTR pSound);
	void		 StartSound(short *pData,unsigned uLen);
	void		 DrawChar(BitmapImage *pImage,int iPosX,int iPosY,char cSign,unsigned uColor);
	static int	 DecodePath(const char *pText,double *pItems,int iMax,int iEnd);
	static int   DecodeTransform(const char *pText,double *pTrans);
	static int	 GetArray(const char *pText,double *pArray,int iMax);
	static int 	 PointOnLine(int iPosX,int iPosY,int iUsed1,int iUsed2);
	static int	 PointOnPoly(int iPosX,int iPosY);
	static void  DrawItemsInit();
	
	static	DWORD WINAPI WaveThread (LPVOID pParam);
	static	DWORD WINAPI ComThread  (LPVOID pParam);
	
	DECLARE_MESSAGE_MAP()


};


//*****************************************************************************
//*
//*		GetDocument
//*
//*****************************************************************************
#ifndef		_DEBUG	
inline CGameSpellDoc *CGameSpellView::GetDocument()
{

return (CGameSpellDoc*)m_pDocument; 
}
#endif



#endif

